#!python
# -*- coding: euc-jp -*-
#
#  TOPPERS ATK2
#      Toyohashi Open Platform for Embedded Real-Time Systems
#      Automotive Kernel Version 2
#
#  Copyright (C) 2013-2014 by Center for Embedded Computing Systems
#              Graduate School of Information Science, Nagoya Univ., JAPAN
#  Copyright (C) 2013-2015 by FUJI SOFT INCORPORATED, JAPAN
#  Copyright (C) 2013-2014 by Panasonic Advanced Technology Development Co., Ltd., JAPAN
#  Copyright (C) 2013-2014 by Renesas Electronics Corporation, JAPAN
#  Copyright (C) 2013-2014 by Sunny Giken Inc., JAPAN
#  Copyright (C) 2013-2014 by TOSHIBA CORPORATION, JAPAN
#  Copyright (C) 2013-2014 by Witz Corporation, JAPAN
#
#  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#  ܥեȥѤΤޤࡥʲƱˤѡʣ
#  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#      ˴ޤޤƤ뤳ȡ
#  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#      ѤǤǺۤˤϡۤȼɥȡ
#      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#      ̵ݾڵǺܤ뤳ȡ
#  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#      ѤǤʤǺۤˤϡΤ줫ξ
#      ȡ
#    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#        𤹤뤳ȡ
#  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#      դ뤳ȡ
#
#  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
#  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
#  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
#  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
#
#  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#  TOPPERSץȤϡܥեȥ˴ؤơλŪ
#  ФŬޤơʤݾڤԤʤޤܥեȥ
#  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#  Ǥʤ
#
# $Id: cancfg.py 122 2015-07-17 01:31:28Z ertl-honda $
#

import os.path
import os
import subprocess
import sys
import time

os.chdir(os.path.dirname(project.Path))

common.Source("./def.py")

src_abs_path = os.path.abspath(SRCDIR)
wd_abs_path = os.path.abspath('.')
proj_rel_dir = ""

common.Source(src_abs_path + "/arch/ccrh/common.py")

project.Create(wd_abs_path + "\\cancfg\\cfg",
				MicomType.RH850, 
				TARGET_MCU, 
				ProjectKind.Empty,
				Compiler.CC_RH,
				False)

str = src_abs_path + '\\' + statup_file
project.File.Add(str, u"ȥå")

project.File.Add("cfg1_out.c", u"configuration")

project.Close(True)

inputstr = ReadFile('./cancfg/cfg.mtpj')
inputstr = NewSetCCRHIncludes(inputstr, cfg_rel_includes, INCLUDES, "../" + SRCDIR)
inputstr = NewSetCCRHIncludes(inputstr, cfg_rel_includes, ['.', 'arch/rs_can', 'target/hsbrh850f1l_ccrh'], '../../../../a-comstack/can/')
inputstr = ChangeItemXml(inputstr, 'OutputMessageFormat-0', '%Program% %Options%')
#inputstr = ChangeItemXml(inputstr, 'UseProEpiRuntimeLibrary-0', 'False')
#inputstr = ChangeItemXml(inputstr, 'HexadecimalFileFormat-0','MotrolaSType32Bit')
inputstr = ChangeItemXml(inputstr, 'HexOptionOutputFileName-0', 'cfg1_out.srec')
inputstr = ChangeItemXml(inputstr, 'LinkOptionShowSymbol-0', 'True')
inputstr = ChangeItemXml(inputstr, 'HexOptionOutputFolder-0', '.')


inputstr = NewSetDefine(inputstr, USER_MACRO)

WriteFile('./cancfg/cfg.mtpj', inputstr)

project.Open('./cancfg/cfg.mtpj')

cfg_command = cfg + " --pass 1 " + "--kernel " + CFG_KERNEL 
cfg_command += " --api-table " + cfg_api_table
cfg_command += " " + cfg_cfg1_def_tables + " --cfg1-def-table ../../../a-comstack/can/arch/rs_can/prc_def.csv " + cfg_includes 
cfg_command += " --ini-file " + cfg_ini_file
cfg_command += " " + cfg_input_str

print cfg_command

try:
	output = subprocess.check_output(cfg_command, stderr=subprocess.STDOUT)
except subprocess.CalledProcessError, e:
	print "ERROR!! : ", e.output

print output

if build.All():

	inputfile = open("./cancfg/DefaultBuild/cfg.map")
	outputfile = open("./cfg1_out.syms", 'w')

	r = re.compile("^\s+([0-9a-f]+)\s+[0-9a-f]+\s+\w+\s+,\w+\s+\*\s+")
	line = inputfile.readline() 
	pre_line = line

	while line:
		line = line.replace('\r\n','')   #delete newline
		m = r.search(line)
		if m:
			outputfile.write(m.group(1) + " T " + pre_line + "\n")
		pre_line = line
		line = inputfile.readline()

	inputfile.close()
	outputfile.close()

project.Close(True)
CubeSuiteExit()
time.sleep(1)
